﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    internal sealed class IdGen
    {
        internal static System.String NewId
        {
            get
            {
                return longToBase64(nextLong());
            }
        }

        internal const long INVALID_WMONID = 0L;

        //  만약 hotfix_enable_wmonid2=true이면 '-'가 '+로 바뀜...,
        static readonly char[] sBitChars = new char[] { 'G', '5', 'g', 'D', 'j', 'P', 'V', 'M', 'R', 'Z', 'm', 'Q', 's', 'N', 'z', '-', 'B', 'i', '4', '_', 'k', '1', 'r', 'U', 'o', 'W', '8', 'l', '9', 'c', 'F', 'O', 'n', 'x', 'L', 'A', 'd', '7', 'u', 'H', '3', '0', 'S', 'a', 'f', 'C', 'h', '6', 'b', 'E', 'T', 'X', 't', 'y', 'q', 'J', '2', 'e', 'p', 'I', 'Y', 'K', 'v', 'w' };
        static readonly long[] charBits = new long['z' + 1];

        private IdGen()
        {
        }

        const int BITS_PER_BYTE = 8;
        const int BYTES_PER_LONG = 8;
        const int BITS_PER_BASE64 = 6;
        const int mask6 = (1 << BITS_PER_BASE64) - 1;

        const int MAX_ID_LENGTH = BITS_PER_BYTE * BYTES_PER_LONG / BITS_PER_BASE64 + 1;

        static System.String longToBase64(long k)
        {
            unchecked
            {
                char[] base64 = new char[MAX_ID_LENGTH];
                for (int i = 0; i < MAX_ID_LENGTH; i++)
                {
                    base64[MAX_ID_LENGTH - i - 1] = sBitChars[(int)(k & mask6)]; // 0x3F)];
                    k = (long)((ulong)k >> BITS_PER_BASE64);
                }
                return new System.String(base64);
            }
        }

        internal static long base64ToLong(System.String base64)
        {
            long k = 0L;
            int length = (base64.Length > MAX_ID_LENGTH) ? MAX_ID_LENGTH : base64.Length;
            for (int i = 0; i < length; i++)
            {
                char c = base64[i];
                k += (charBits[c] << ((length - i - 1) * BITS_PER_BASE64));
            }
            return k;
        }

        const long multiplier = 0x5DEECE66DL;
        const long addend = 0xBL;
        const long mask48 = (1L << 48) - 1;
        static long seed = (DateTime.Now.Ticks ^ multiplier) & mask48;
        static readonly object syncLock = new object();

        static int next(int bits)
        {
            unchecked
            {
                lock (syncLock)
                {
                    long nextseed = unchecked((seed * multiplier + addend) & mask48);
                    seed = nextseed;
                    return (int)((ulong)nextseed >> (48 - bits));
                }
            }
        }

        //internal static long nextLong()
        //{
        //    return ((long)(next(32)) << 32) + next(32);
        //}

        internal static long nextLong()
        {
            return ((long)(next(32)) << 32) + next(32);
        }

        static IdGen()
        {
            charBits['G'] = 0; charBits['5'] = 1; charBits['g'] = 2; charBits['D'] = 3;
            charBits['j'] = 4; charBits['P'] = 5; charBits['V'] = 6; charBits['M'] = 7;
            charBits['R'] = 8; charBits['Z'] = 9; charBits['m'] = 10; charBits['Q'] = 11;
            charBits['s'] = 12; charBits['N'] = 13; charBits['z'] = 14; charBits['-'] = 15;
            charBits['B'] = 16; charBits['i'] = 17; charBits['4'] = 18; charBits['_'] = 19;
            charBits['k'] = 20; charBits['1'] = 21; charBits['r'] = 22; charBits['U'] = 23;
            charBits['o'] = 24; charBits['W'] = 25; charBits['8'] = 26; charBits['l'] = 27;
            charBits['9'] = 28; charBits['c'] = 29; charBits['F'] = 30; charBits['O'] = 31;
            charBits['n'] = 32; charBits['x'] = 33; charBits['L'] = 34; charBits['A'] = 35;
            charBits['d'] = 36; charBits['7'] = 37; charBits['u'] = 38; charBits['H'] = 39;
            charBits['3'] = 40; charBits['0'] = 41; charBits['S'] = 42; charBits['a'] = 43;
            charBits['f'] = 44; charBits['C'] = 45; charBits['h'] = 46; charBits['6'] = 47;
            charBits['b'] = 48; charBits['E'] = 49; charBits['T'] = 50; charBits['X'] = 51;
            charBits['t'] = 52; charBits['y'] = 53; charBits['q'] = 54; charBits['J'] = 55;
            charBits['2'] = 56; charBits['e'] = 57; charBits['p'] = 58; charBits['I'] = 59;
            charBits['Y'] = 60; charBits['K'] = 61; charBits['v'] = 62; charBits['w'] = 63;
        }
    }
}
